package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.GP_PricingTipoServicioDAO;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingTipoServicio;
import com.rjconsultores.ventaboletos.entidad.TipoServicio;
import com.rjconsultores.ventaboletos.service.GP_PricingTipoServicioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("gp_pricingTipoServicioService")
public class GP_PricingTipoServicioServiceImpl implements GP_PricingTipoServicioService {

	@Autowired
	private GP_PricingTipoServicioDAO pricingTipoServicioDAO;

	public List<GP_PricingTipoServicio> obtenerTodos() {
		return pricingTipoServicioDAO.obtenerTodos();
	}

	public GP_PricingTipoServicio obtenerID(Integer id) {
		return pricingTipoServicioDAO.obtenerID(id);
	}

	@Transactional
	public GP_PricingTipoServicio suscribir(GP_PricingTipoServicio entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.ATIVO);

		return pricingTipoServicioDAO.suscribir(entidad);
	}

	@Transactional
	public GP_PricingTipoServicio actualizacion(GP_PricingTipoServicio entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.ATIVO);

		return pricingTipoServicioDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(GP_PricingTipoServicio entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.EXCLUIDO);

		pricingTipoServicioDAO.actualizacion(entidad);
	}

	public Boolean obtenerPricingTipoServicio(GP_Pricing pricing, TipoServicio tipoServicio) {
		return pricingTipoServicioDAO.obtenerPricingTipoServicio(pricing, tipoServicio);
	}

	@Override
	public List<GP_PricingTipoServicio> obtenerTodoPorPricing(GP_Pricing pricing) {
		return  pricingTipoServicioDAO.obtenerTodoPorPricing(pricing);
	}
}
